<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8">
<!-- Initialize Bootstrap 4 -->
<link rel="stylesheet" href="https://cdn.staticfile.org/twitter-bootstrap/4.3.1/css/bootstrap.min.css">
<script src="https://cdn.staticfile.org/jquery/3.2.1/jquery.min.js"></script>
<script src="https://cdn.staticfile.org/popper.js/1.15.0/umd/popper.min.js"></script>
<script src="https://cdn.staticfile.org/twitter-bootstrap/4.3.1/js/bootstrap.min.js"></script>
<link rel="stylesheet" type="text/css" href="css/global.css">
<script src="getTokenFromCookie.js"></script>
<title>Liste des personnes</title>
</head>
<body>
	<ul class="nav justify-content-end">
		<li class="nav-item">
			<button type="button" id="bouton-logout" class="btn btn-light" style="border: 0.5px solid lightgray;">Log out</button>
			<button type="button" id="bouton-fichiers" class="btn btn-light" style="border: 0.5px solid lightgray;">Accueil</button>
		</li>
	</ul>

    <h1>Liste des personnes</h1>
    <table class="table table-hover">
        <thead>
            <tr>
                <th>User Name</th>
                <th>Role</th>
                <th>Year</th>
                <th>First name</th>
                <th>Last name</th>
                <th>E-mail</th>
            </tr>
        </thead>
        <tbody id="personnels">
        </tbody>
    </table>
    <!--Visible si usr est admin--> 
    <button class="btn btn-outline-success" data-toggle="modal" data-target="#personel" style="float:right;">Ajouter</button><br>

    <div class="modal fade" id="personel">
        <div class="modal-dialog">
          <div class="modal-content">
       
            <div class="modal-header">
              <h4 class="modal-title">Ajouter ou modifier une personne</h4>
              <button type="button" class="close" data-dismiss="modal">&times;</button>
            </div>
       
            <div class="modal-body">
                <form>
                    <table>
                        <tr>
                            <td>User name</td>
                            <td><input type="text" class="form-control" id="nom"></td>
                        </tr>
                        <tr>
                            <td>Password</td>
                            <td><input type="text" class="form-control" id="pwd"></td>
                        </tr>
                        <tr>
                            <td>Year</td>
                            <td>
                                <div class="input-group">
                                    <input type="text" class="form-control" id="annee">
                                    <div class="input-group-append">
                                        <span class="input-group-text">IF</span>
                                    </div>
                                </div>
                            </td>
                        </tr>
                        <tr>
                            <td>Role</td>
                            <td>
                                <form>
                                    <div class="radio">
                                        <label><input type="radio" name="role" id="student" value="student">Student</label>
                                    </div>
                                    <div class="radio">
                                        <label><input type="radio" name="role" id="professor" value="professor">Professor</label>
                                    </div>
                                    <div class="form-check">
                                        <label class="form-check-label">
                                          <input type="checkbox" class="form-check-input" name="role" id="admin" value="admin">Admin
                                        </label>
                                      </div>
                                </form>
                            </td>
                        </tr>
                    </table>
                    
                </form>
            </div>

            <div class="modal-footer">
                <button type="submit" class="btn btn-primary" id="sauvgarder">Sauvgarder</button>
            </div>
        </div>
       
        </div>
    </div>

<script>
    $('#personel').on('show.bs.modal', function (event) {
    let nom = $(event.relatedTarget).data('nom') 
    if(nom){    // Update
        console.log("--------------UPDATE------------------")
        let role = $(event.relatedTarget).data('role') 
        let annee = $(event.relatedTarget).data('annee') 
        $(document).find('.modal-body #nom').val(nom)
        $(document).find('.modal-body #annee').val(annee)

        $(document).find('.modal-body #pwd').val("")
        if(role){
            var  items = ["student", "professor","admin"];
            items.forEach(function(item){
                if(role.includes(item.toString())){
                    $(document).find(".modal-body #"+item.toString().toLowerCase()).prop("checked", true);
                }
                else{
                    $(document).find(".modal-body #"+item.toString().toLowerCase()).prop("checked", false);
                }
            });
        }

        $("#sauvgarder").click(function(e){
            let reqUrl = "http://localhost:8000/api/admin/user?username="+nom;
            let newPwd = $("#pwd").val();
            if(newPwd)
            reqUrl = reqUrl+"&password="+newPwd;

            let newAnnee = $("#annee").val();
            if(newAnnee)
            reqUrl = reqUrl+"&year="+newAnnee;

            var ele = document.getElementsByName('role'); 
            for(i = 0; i < ele.length; i++) { 
                if(ele[i].checked) {
                    reqUrl = reqUrl+"&roles="+ele[i].value;
                    console.log("role added"+ele[i].value)
                }
            } 
            console.log(reqUrl)

            $.ajax({
                type: "POST",
                headers:{"Authorization":"Bearer "+getTokenFromCookie()},
                url: reqUrl,
                success: (data) => {
                    console.log("user updated")
                    location.reload()                
                },
                error: (err) => {
                    console.log("Error message user update：" + JSON.stringify(err))
                    alert(err.statusText);          
                }
            })
        });
    }
    else{       //Ajout
        console.log("--------------AJOUT------------------")
        $(document).find('.modal-body #nom').val("")
        $(document).find('.modal-body #annee').val("")
        $(document).find('.modal-body #pwd').val("")
        var  items = ["student", "professor","admin"];
        items.forEach(function(item){
            $(document).find(".modal-body #"+item.toString().toLowerCase()).prop("checked", false);
        });

        $("#sauvgarder").click(function(e){
            let newNom = $("#nom").val();
            let newPwd = $("#pwd").val();
            let newAnnee = $("#annee").val();
            let reqUrl = "http://localhost:8000/api/admin/user?username="+newNom+"&password="+newPwd+"&year="+newAnnee;
            
            var ele = document.getElementsByName('role'); 
            for(i = 0; i < ele.length; i++) { 
                if(ele[i].checked) {
                    reqUrl = reqUrl+"&roles="+ele[i].value;
                    console.log("role added"+ele[i].value)
                }
            } 
            console.log(reqUrl)

            $.ajax({
                type: "PUT",
                headers:{"Authorization":"Bearer "+getTokenFromCookie()},
                url: reqUrl,
                success: (data) => {
                    console.log("user added")
                    location.reload()                
                },
                error: (err) => {
                    console.log("Error message user addition ：" + JSON.stringify(err))
                    alert(err.statusText);
                }
            })
        });
    }
    });

    $(document).ready(function(){
		$('#bouton-logout').on('click', function () {
			document.cookie = "token=;expires=Thu, 01 Jan 1970 00:00:01 GMT";
			window.location.href= "login.html";
		});
		$('#bouton-fichiers').on('click', function () {
			window.location.href= "fichiers.html";
		});
        $.ajax({
            type: "GET",
            async: true,
            headers:{"Authorization":"Bearer "+getTokenFromCookie()},
            url: "http://localhost:8000/api/admin/user",
            success: (data) => {
                var jsonData = JSON.parse(data);
                $.each(jsonData.result, function() {
                    var thedata = $("#personnels");
                    var trAttr = "<tr data-toggle='modal' data-target='#personel' data-nom="+this.username.toString()+" data-role="+this.roles.toString()
                    if(this.year){
                        trAttr += " data-annee="+this.year.toString();
                    }
                    if(this.firstname){
                        trAttr += " data-firstname="+this.firstname.toString();
                    }
                    if(this.lastname){
                        trAttr += " data-lastname="+this.lastname.toString();
                    }
                    if(this.email){
                        trAttr += " data-email="+this.email.toString();
                    }
                    trAttr += ">"

                    var trData = "<td>"+this.username.toString()+"</td><td>"+ this.roles.toString() +"</td>";
                    if(this.year){
                        trData += "<td>"+ this.year.toString() +"</td>";
                    }
                    if(this.firstname){
                        trData += "<td>"+ this.firstname.toString() +"</td>";
                    }
                    if(this.lastname){
                        trData += "<td>"+ this.lastname.toString() +"</td>";
                    }
                    if(this.email){
                        trData += "<td>"+ this.email.toString() +"</td>";
                    }
                    trData += "</tr>"
                    thedata.append(trAttr+trData);
                })
            },
            error: (err) => {
                console.log("Error message load ：" + JSON.stringify(err))
                alert(err.statusText);
            }
        })
    })
    

</script>
</body>
</html>
